#include <jni.h>
#include <stdio.h>
#include "speex/speex.h"

 #define FRAME_SIZE 320


void Java_com_m2_iSmartDm_ISmartDMActivity_spxDec(JNIEnv * env, jobject jobj,jstring dir1,jstring dir2)
{
	const char *inFile= (*env)->GetStringUTFChars(env,dir1,0);
	const char *outFile= (*env)->GetStringUTFChars(env,dir2,0);
	FILE *fin;
	FILE *fout;

 short out[FRAME_SIZE];

 short output[FRAME_SIZE];
 char cbits[360];
 int nbBytes;

 void *state;

 SpeexBits bits;
 int i, tmp;
 jbyteArray bytes;

  state = speex_decoder_init(&speex_wb_mode);


  tmp=1;
  speex_decoder_ctl(state, SPEEX_SET_ENH, &tmp);

  fin = fopen(inFile, "r");
  fout=fopen(outFile,"w");

  speex_bits_init(&bits);


  while (!feof(fin))
   {

   
   	fread(&nbBytes, sizeof(int), 1, fin);
   	if (feof(stdin))
   	 break;

   
   	fread(cbits, 1, nbBytes, fin);

   
  	speex_bits_read_from(&bits, cbits, nbBytes);


  	speex_decode_int(state, &bits, output);
    


    	fwrite(output, sizeof(short), FRAME_SIZE, fout);
   }
   
   speex_decoder_destroy(state);
   
   speex_bits_destroy(&bits);
   fclose(fout);
   fclose(fin);


}